function abcImageFormat(format, data) {
  var ids = [], text = "";
  if (format.match(/\{##\}/)) {
    data.forEach(function(img) {
      ids.push(img.id);
    });
    text = format.replace(/\{##\}/g, ids.join(","));
  } else data.forEach(function(img) {
      let chunk = img.id ? format.replace(/\{#\}/g, img.id) : format;
      for (let [key, value] of Object.entries(img)) if (typeof value == "undefined") {
        chunk = chunk.replace(new RegExp("\\s+\\w+=[\"']{"+key+"}[\"']", "g"), "").replace(new RegExp("{"+key+"}", "g"), "");
      } else {
        let val = value.toString().replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
        chunk = chunk.replace(new RegExp("{"+key+"}", "g"), val)
      }
      text += chunk;
    });
  return text;
}

function readfiles(files, input) {
var formData = new FormData(), count = 0;

for (var i = 0; i < files.length; i++) {
    if (files[i].type.match(/^image\//)) {
        formData.append("thefile[]", files[i]);
        count++;
    }
}

var text = "Upload "+count+" image"+(count == 1 ? "" : "s")+"?";
if (!count || !window.confirm(text)) return 0;

formData.append("_txp_token", textpattern._txp_token);
$(input).prop("disabled", true);

$.ajax({
    url: "index.php?event=image&step=image_insert&app_mode=async",
    type: "POST",
    data: formData,
    async: true,
    success: function (data) {
        var text = typeof abcImage == "undefined" ? "" : abcImageFormat(imageTag, abcImage);
        textpattern.Relay.data.fileid = abcImage = [];
        $(input).prop("disabled", false);
        insertAtCursor(input, text);
        textpattern.Console.announce("uploadEnd");
    },
    cache: false,
    contentType: false,
    processData: false
 });
return count;
}       

$("#body, #excerpt").on("dragover", function(evt) {
    e = evt.originalEvent;
    if (e.dataTransfer.types.includes("Files")) {
        e.stopPropagation();
        e.preventDefault();
        e.dataTransfer.dropEffect = "copy";
    }
}).on("drop", function(evt) {
    var e = evt.originalEvent, count = 0
    if (e.dataTransfer.files.length) {//console.log(e.dataTransfer.files)
        count = readfiles(e.dataTransfer.files, this);
    }
    if (count)
        e.preventDefault();
    else {
        var img = $("<div>"+e.dataTransfer.getData("text/html")+"</div>").find("img");
        var text = "";
        if (img.length) {
          img.each(function( index ) {
            var $this = $(this);
            if ($this.attr("src") || $this.attr("srcset")) {
              var atts = {
                src: $this.attr("src"),
                srcset: $this.attr("srcset"),
                sizes: $this.attr("sizes"),
                alt: $this.attr("alt"),
                title: $this.attr("title"),
                h: $this.attr("height"),
                w: $this.attr("width")
              };
              if (imageLink) {
                text += abcImageFormat(imageLink, [atts]);
              }
              else {
                var tmpimg = $("<img />").attr(atts);
                text += tmpimg.prop("outerHTML");
              }
            }
          });
        }
        if (text || !this.setRangeText) {
          e.preventDefault();
          insertAtCursor(this, text || e.dataTransfer.getData("text/plain"));
        }
    }
});

$("#txp-image-group-content").on("click", "#article-file-reset", function(e) {
	e.preventDefault();
	$("#article-file-input").val("");
	$("#article-file-preview").empty();
	$("#article-file-reset").css("visibility", "hidden");
}).on("click", ".sortable .destroy", function(e) {
	e.preventDefault();
	$(this).parent().removeClass("sortable").clone().appendTo("#article-file-select");
	$(this).parent().remove();
	$("#txp-image-group-content").trigger("sortupdate").sortable("refresh");
}).on("click", "#article-file-add", function(e) {
	e.preventDefault();
	$(this).children("span").toggleClass("ui-icon-arrowthickstop-1-s ui-icon-arrowthickstop-1-n");
	$("#article-file-select").toggleClass("hidden");
}).on("dragstart", "#article-file-container a, #article-file-select a", function(e) {
//      console.log(e.originalEvent)
      var dragged = e.originalEvent.dataTransfer.getData("text/html") || e.originalEvent.target;
	    var imgs = $(dragged).find("img");
	    var text = "", data = [];
	    imgs.each(function() {
        data.push({alt: $(this).attr("alt"), id: $(this).data("id"), w: $(this).data("width"), h: $(this).data("height"), src: imageDir+"/"+$(this).data("id")+$(this).data("ext")});
      })
      text = abcImageFormat(imageTag, data);
	    e.originalEvent.dataTransfer.setData("text/plain", text);
	    e.originalEvent.dataTransfer.setData("text/html", "");
}).on("sortupdate", function( event ) {
	var $container = $("#article-file-container"), list = [];
	$container.children("p.sortable").each(function() {
		list.push($(this).data("id"));
	});
	$("#article-image").val(list.join());
}).on("click", "#article-file-select a", function(e) {
	e.preventDefault();
	$(this).parent().addClass("sortable").appendTo("#article-file-container");
	$("#txp-image-group-content").trigger("sortupdate").sortable("refresh");
});

$("#txp-image-group-content").on("dragend", "#article-file-container a", function(e) {
	$("#txp-image-group-content").sortable("enable");
}).sortable({
	items: ".sortable",
	out: function (event, ui) {
		if (!!droppedOutside) $(this).sortable("disable");
	},
	over: function (event, ui) {
		$(this).sortable("enable");
	},
	beforeStop: function (event, ui) {droppedOutside = false;
	},
	start: function (event, ui) {droppedOutside = true;
	}
});

function insertAtCursor (input, textToInsert) {
  const isSuccess = document.execCommand("insertText", false, textToInsert);
  if (isSuccess) return;

  // IE 8-10
  if (document.selection) {
    const ieRange = document.selection.createRange();
    ieRange.text = textToInsert;

    // Move cursor after the inserted text
    ieRange.collapse(false /* to the end */);
    ieRange.select();

    return;
  }

  // Firefox (non-standard method)
  if (typeof input.setRangeText === "function") {
    const start = input.selectionStart;
    input.setRangeText(textToInsert);
    // update cursor to be at the end of insertion
    input.selectionStart = input.selectionEnd = start + textToInsert.length;

  } else if (input.selectionStart || input.selectionStart == '0') {
      var startPos = input.selectionStart;
      var endPos = input.selectionEnd;
      input.value = input.value.substring(0, startPos)
          + textToInsert
          + input.value.substring(endPos, input.value.length);
      input.selectionStart = startPos + textToInsert.length;
      input.selectionEnd = startPos + textToInsert.length;
  } else {
      input.value += textToInsert;
  }
    // Notify any possible listeners of the change
//    const e = document.createEvent("UIEvent");
//    e.initEvent("input", true, false);
    const e = new Event("input", {"bubbles":true, "cancelable":false});
    input.dispatchEvent(e);
}

window.abcPreview = function (input) {
	var createObjectURL = (window.URL || window.webkitURL || {}).createObjectURL

	if (createObjectURL && input.files.length) {
		$("#article-file-preview").empty();
		$("#article-file-reset").css("visibility", "visible");
		$(input.files).each(function () {
			$("#article-file-preview").append("<p><img src=\'" + createObjectURL(this) + "\' /></p>");
		});
	}
}